# Module to print text files under Windows.
# Rick Smereka, Copyright (C) 2004-2005.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, get a copy via the Internet at
# http://gnu.org/copyleft/gpl.html or write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307 USA

# You can contact the author via email at rsmereka@future-lab.com

# Initial tcl version. Feb/2004, Rick Smereka
# Code for this procedure taken from wiki.tcl.tk/9846
# Only text can be printed. Windows 'Notepad' application is used to
# print.
proc PrintText {fname} {
   # Print a file under Windows.
   package require registry
   set app [registry get {HKEY_CLASSES_ROOT\.txt} {}]
   set pcmd [registry get HKEY_CLASSES_ROOT\\$app\\shell\\print\\command {}]
   set filename [file attribute $fname -shortname]
   regsub -all {%1} $pcmd [file normalize $filename] pcmd
   set command "[auto_execok start] /min [regsub -all {\\} $pcmd {\\\\}]"
   eval exec $command &
}
